<?php
namespace app\common\model;
use think\Db;
use think\Cache;

class Art2 extends Base {

    protected $name = 'art';
    protected $createTime = '';
    protected $updateTime = '';
    protected $auto       = [];
    protected $insert     = [];
    protected $update     = [];

    public function countData($where)
    {
        $total = $this->where($where)->count();
        return $total;
    }

    public function listData($where,$order,$page=1,$limit=20,$start=0,$field='*',$addition=1,$totalshow=1)
    {
        if(!is_array($where)){
            $where = json_decode($where,true);
        }
        $where2='';
        if(!empty($where['_string'])){
            $where2 = $where['_string'];
            unset($where['_string']);
        }

        $limit_str = ($limit * ($page-1) + $start) .",".$limit;
        if($totalshow==1) {
            $total = $this->where($where)->count();
        }
        $list = Db::name('Art')->field($field)->where($where)->where($where2)->order($order)->limit($limit_str)->select();

        $type_list = model('Type')->getCache('type_list');
        foreach($list as $k=>$v){
            if($addition==1){
                if(!empty($v['type_id'])) {
                    $list[$k]['type_name'] = $type_list[$v['type_id']]['type_name'];
                }
            }
            if(!empty($v['art_pwd'])) {
                $list[$k]['art_pwd'] = "ok";
            }
        }

        return ['code'=>1,'msg'=>lang('data_list'),'page'=>$page,'pagecount'=>ceil($total/$limit),'limit'=>$limit,'total'=>$total,'list'=>$list];
    }

    public function listCacheData($lp)
    {

        if (!is_array($lp)) {
            $lp = json_decode($lp, true);
        }

        $order = $lp['order'];
        $by = $lp['by'];
        $type = $lp['type'];
        $wd = $lp['wd'];
        $tag = $lp['tag'];
        $start = intval(abs($lp['start']));
        $num = intval(abs($lp['num']));
        $cachetime = $lp['cachetime'];
        $typenot = $lp['typenot'];
        $name = $lp['name'];
        $page = $lp['page'];
        $where = [];
        $totalshow=$lp['paging'];

        if($start>1){
            $start--;
        }

        $where['art_status'] = ['eq',1];
        if(!empty($type)) {
            $where['type_id|type_id_1'] = ['eq',$type];
        }
        if(!empty($typenot)){
            $where['type_id'] = ['not in',$typenot];
        }
        if(!empty($wd)) {
            $role = 'art_name';
            if(!empty($GLOBALS['config']['app']['search_art_rule'])){
                $role .= '|'.$GLOBALS['config']['app']['search_art_rule'];
            }
            $where[$role] = ['like', '%' . $wd . '%'];
        }
        if(!empty($name)) {
            $where['art_name'] = ['like', mac_like_arr($name),'OR'];
        }
        if(!empty($tag)) {
            $where['art_tag'] = ['like', mac_like_arr($tag),'OR'];
        }
        if($by=='rnd'){
            $data_count = $this->countData($where);
            $page_total = floor($data_count / $lp['num']) + 1;
            if($data_count < $lp['num']){
                $lp['num'] = $data_count;
            }
            $randi = @mt_rand(1, $page_total);
            $page = $randi;
            $by = 'hits_week';
            $order = 'desc';
        }

        if(!in_array($by, ['id' ,'time','time_add','score','hits','hits_day','hits_week','hits_month','up','down','level','rnd'])) {
            $by = 'time';
        }
        if(!in_array($order, ['asc', 'desc'])) {
            $order = 'desc';
        }
        $order= 'art_'.$by .' ' . $order;
        $where_cache = $where;
        if(!empty($randi)){
            unset($where_cache['art_id']);
            $where_cache['order'] = 'rnd';
        }
        $cach_name = $GLOBALS['config']['app']['cache_flag']. '_' .md5('art_listapi_'.http_build_query($where_cache).'_'.$order.'_'.$page.'_'.$num.'_'.$start);
        $res = Cache::get($cach_name);
        if(empty($cachetime)){
            $cachetime = $GLOBALS['config']['app']['cache_time'];
        }
        if($GLOBALS['config']['app']['cache_core']==0 || empty($res)) {
            $res = $this->listData($where,$order,$page,$num,$start,['art_name','art_color','art_level','art_id','type_id','type_id_1','art_sub','art_tag','art_pic','art_blurb','art_time','art_hits','art_pwd','art_points'],1,$totalshow);
            if($GLOBALS['config']['app']['cache_core']==1) {
                Cache::set($cach_name, $res, $cachetime);
            }
        }
        return $res;
    }

}