<?php
namespace addons\streamlab\library;

class Ds
{

    protected $server  = [];

    /**
     * get请求
     * @param string url 请求网址
     * @param bool json 返回数据类型
     * @return string|array
     */
    public static function curl_get($url,$json=false)
    {
        $ch = @curl_init();
        curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36');
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 15);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_HEADER,0);
        curl_setopt($ch, CURLOPT_POST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 1);
        curl_setopt($ch, CURLOPT_REFERER, $url);
        $response = @curl_exec($ch);
        curl_close($ch);
        if($json == true){
            $response = json_decode($response, true);
        }
        return $response;
    }

    /**
     * 格式化数字
     * @param number number 需要转换的数字
     * @return string
     */
    public static function FormatMoney($number):string{
        $length = strlen($number);
        if($length > 8){
            $str = substr_replace(strstr($number,substr($number,-7),' '),'.',-1,0)."亿";
        }elseif($length >4){
            $str = substr_replace(strstr($number,substr($number,-3),' '),'.',-1,0)."万";
        }else{
            return $number;
        }
        return $str;
    }

    /**
     * 全部过滤
     * @param string txt  需要过滤的文本
     * @return string
     */
    public static function all_filter($txt):string{
        $html = ds::safe_replace($txt);
        $html = ds::remove_xss($html);
        return $html;
    }

    /**
     * 安全过滤函数
     *
     * @param $string
     * @return string
     */
    public static function safe_replace($string):string {
        $string = str_replace('%20','',$string);
        $string = str_replace('%27','',$string);
        $string = str_replace('%2527','',$string);
        $string = str_replace('*','',$string);
        $string = str_replace("'",'',$string);
        $string = str_replace('<','<',$string);
        $string = str_replace('>','>',$string);
        $string = str_replace('GLOBALS','',$string);
        $string = str_replace('entrance','',$string);
        $string = str_replace('\\','',$string);
        $string = str_replace('function','',$string);
        return $string;
    }
    /**
     * 安全过滤函数
     *
     * @param $string
     * @return string
     */
    public static function safe_replace2($string):string {
        $string = htmlspecialchars(urldecode(trim($string)));
        $string = str_replace('%20','',$string);
        $string = str_replace('%27','',$string);
        $string = str_replace('%2527','',$string);
        $string = str_replace('*','',$string);
        $string = str_replace("'",'',$string);
        $string = str_replace('{','',$string);
        $string = str_replace("}",'',$string);
        $string = str_replace('<','<',$string);
        $string = str_replace('>','>',$string);
        $string = str_replace('"','',$string);
        $string = str_replace('\\','',$string);
        $string = str_replace("or","",$string);
        $string = str_replace("=","",$string);
        $string = str_replace('function','',$string);
        $string = str_replace('?','',$string);
        $string = str_replace("and","",$string);
        $string = str_replace("execute","",$string);
        $string = str_replace("update","",$string);
        $string = str_replace("count","",$string);
        $string = str_replace("chr","",$string);
        $string = str_replace("master","",$string);
        $string = str_replace("truncate","",$string);
        $string = str_replace("char","",$string);
        $string = str_replace("declare","",$string);
        $string = str_replace("select","",$string);
        $string = str_replace("create","",$string);
        $string = str_replace("delete","",$string);
        $string = str_replace("insert","",$string);
        return $string;
    }

    /**
     * xss过滤函数
     * @param $string
     * @return string
     */
    public static function remove_xss($string):string {
        $string = preg_replace('/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]+/S', '', $string);
        $parm1 = Array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'xml', 'blink', 'link', 'script', 'embed', 'object', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound', 'title', 'base');
        $parm2 = Array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
        $parm = array_merge($parm1, $parm2);
        for ($i = 0; $i < sizeof($parm); $i++) {
            $pattern = '/';
            for ($j = 0; $j < strlen($parm[$i]); $j++) {
                if ($j > 0) {
                    $pattern .= '(';
                    $pattern .= '(&#[x|X]0([9][a][b]);?)?';
                    $pattern .= '|(&#0([9][10][13]);?)?';
                    $pattern .= ')?';
                }
                $pattern .= $parm[$i][$j];
            }
            $pattern .= '/i';
            $string = preg_replace($pattern, ' ', $string);
        }
        return $string;
    }

    /**
     * 过滤ASCII码从0-28的控制字符
     * @param $str
     * @return String
     */
    public static function trim_unsafe_control_chars($str):string {
        $rule = '/[' . chr ( 1 ) . '-' . chr ( 8 ) . chr ( 11 ) . '-' . chr ( 12 ) . chr ( 14 ) . '-' . chr ( 31 ) . ']*/';
        return str_replace ( chr ( 0 ), '', preg_replace ( $rule, '', $str ) );
    }

    /**
     * 将图片转为base64
     * @param $img
     * @return String
     */
    public static function data_url_img($img):string{
        header('Content-type:text/html;charset=utf-8');
        $image_info = getimagesize($img);
        return "data:{$image_info['mime']};base64," . base64_encode(file_get_contents($img));
    }

    public static function label_eccms($aid)
    {
        $maccms = $GLOBALS['config']['site'];
        $maccms['path'] = MAC_PATH;
        $maccms['path_tpl'] = MAC_PATH_TEMPLATE;
        $maccms['path_ads'] = MAC_PATH_ADS;
        $maccms['user_status'] = $GLOBALS['config']['user']['status'];
        $maccms['date'] = date('Y-m-d');
        $maccms['share_url'] = $GLOBALS['config']['app']['share_url'];
        $maccms['search_hot'] = $GLOBALS['config']['app']['search_hot'];
        $maccms['art_extend_class'] = $GLOBALS['config']['app']['art_extend_class'];
        $maccms['vod_extend_class'] = $GLOBALS['config']['app']['vod_extend_class'];
        $maccms['vod_extend_state'] = $GLOBALS['config']['app']['vod_extend_state'];
        $maccms['vod_extend_version'] = $GLOBALS['config']['app']['vod_extend_version'];
        $maccms['vod_extend_area'] = $GLOBALS['config']['app']['vod_extend_area'];
        $maccms['vod_extend_lang'] = $GLOBALS['config']['app']['vod_extend_lang'];
        $maccms['vod_extend_year'] = $GLOBALS['config']['app']['vod_extend_year'];
        $maccms['vod_extend_weekday'] = $GLOBALS['config']['app']['vod_extend_weekday'];
        $maccms['actor_extend_area'] = $GLOBALS['config']['app']['actor_extend_area'];
        $maccms['http_type'] = $GLOBALS['http_type'];
        $maccms['aid'] = $aid;
        return $maccms;
    }
}